#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ResolvedAggregationUdfReturnShape {
    #[serde(rename = "SCALAR")]
    Scalar,
    #[serde(rename = "TIMESTAMPED_VALUE")]
    TimestampedValue,
    #[serde(rename = "TIMESTAMPED_VALUES")]
    TimestampedValues,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ResolvedAggregationUdfReturnShape {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ResolvedAggregationUdfReturnShape::Scalar => "SCALAR",
            ResolvedAggregationUdfReturnShape::TimestampedValue => "TIMESTAMPED_VALUE",
            ResolvedAggregationUdfReturnShape::TimestampedValues => "TIMESTAMPED_VALUES",
            ResolvedAggregationUdfReturnShape::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ResolvedAggregationUdfReturnShape {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ResolvedAggregationUdfReturnShape {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ResolvedAggregationUdfReturnShape {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<
        ResolvedAggregationUdfReturnShape,
        conjure_object::plain::ParseEnumError,
    > {
        match v {
            "SCALAR" => Ok(ResolvedAggregationUdfReturnShape::Scalar),
            "TIMESTAMPED_VALUE" => {
                Ok(ResolvedAggregationUdfReturnShape::TimestampedValue)
            }
            "TIMESTAMPED_VALUES" => {
                Ok(ResolvedAggregationUdfReturnShape::TimestampedValues)
            }
            v => {
                v.parse().map(|v| ResolvedAggregationUdfReturnShape::Unknown(Unknown(v)))
            }
        }
    }
}
impl conjure_object::FromPlain for ResolvedAggregationUdfReturnShape {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<
        ResolvedAggregationUdfReturnShape,
        conjure_object::plain::ParseEnumError,
    > {
        v.parse()
    }
}
///An unknown variant of the ResolvedAggregationUdfReturnShape enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
